/*
 * Copyright (c) 2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 *
 * http://hardware.ispras.ru
 *
 * This code implements working with standard linux context.
 */

#include "sync_common.c"

static TestScenario *__localscen;
static TestScenario *__localinitscen;

static void scenario_wrapper(void)
{
    if(!netscenario)
        localmain(&TE_NDFSM, __localscen, parsed_argc, parsed_argv);
    else
        netmain(&TE_NDFSM, __localscen, parsed_argc, parsed_argv);
}

static void scenario_wrapper_with_init(void)
{
    localmain(&TE_NDFSM, __localinitscen, parsed_argc, parsed_argv);
    if(!netscenario)
        localmain(&TE_NDFSM, __localscen, parsed_argc, parsed_argv);
    else
        netmain(&TE_NDFSM, __localscen, parsed_argc, parsed_argv);
}

static void scenario_wrapper_new(void)
{
	if(!netscenario)
		localmain(local_testEngine, __localscen, parsed_argc, parsed_argv);
	else
		netmain(local_testEngine, __localscen, parsed_argc, parsed_argv);
}
static void scenario_wrapper_with_init_new(void)
{
	localmain(local_testEngine, __localscen, parsed_argc, parsed_argv);
    if(!netscenario)
        localmain(local_testEngine, __localscen, parsed_argc, parsed_argv);
    else
        netmain(local_testEngine, __localscen, parsed_argc, parsed_argv);
}

int start_scenario_new(TestScenario *scen, TestEngine *testEngine, char *params, bool netscen, bool initscen)
{
    __localscen = scen;
    local_testEngine = testEngine;
	parse_parameters(params, __localscen->name);
	netscenario = netscen;
	initscenario = initscen;

	getcontext(&scenario_context);
	scenario_context.uc_link = &testbench_context;
	scenario_context.uc_stack.ss_sp = stack;
	scenario_context.uc_stack.ss_size = SIGSTKSZ;
	makecontext(&scenario_context, initscenario ? scenario_wrapper_with_init_new : scenario_wrapper_new, 0);
	swapcontext(&testbench_context, &scenario_context);

	return 0;
}

int start_scenario(TestScenario *scen, char *params)
{
    __localscen = scen;
    parse_parameters(params, __localscen->name);

    getcontext(&scenario_context);
    scenario_context.uc_link = &testbench_context;
    scenario_context.uc_stack.ss_sp = stack;
    scenario_context.uc_stack.ss_size = SIGSTKSZ;
    makecontext(&scenario_context, initscenario ? scenario_wrapper_with_init : scenario_wrapper, 0);
    swapcontext(&testbench_context, &scenario_context);

    return 0;
}

int start_net_scenario(TestScenario *scen, char *params)
{
    netscenario = true;
    return start_scenario(scen, params);
}

int start_scenario_with_init(TestScenario *initscen, TestScenario *scen, char *params)
{
    __localinitscen = initscen;
    initscenario    = true;
    return start_scenario(scen, params);
}

int start_net_scenario_with_init(TestScenario *initscen, TestScenario *scen, char *params)
{
    netscenario = true;
    return start_scenario_with_init(initscen, scen, params);
}

