/*
 * Copyright (c) 2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 *
 * http://hardware.ispras.ru
 */

#ifndef _SYNC_H_INCLUDED_
#define _SYNC_H_INCLUDED_

#ifdef __cplusplus
#include <engines.hpp>
using namespace cpptesk::ts;
#else
#include <engines.h>
#endif // __cplusplus

#define TEST_REGISTRY_BEGIN \
	test_registry_item test_registry[] = {

#define TEST_REGISTRY_END \
		{ NULL, CTESK, NULL, NULL, NULL } };

#define REGISTER_CPPTESK_TEST(test, engine, params) \
	    { #test, CPPTESK, &test, engine, params },

#define REGISTER_CTESK_TEST(test, engine, params) \
	    { #test, CTESK, &test, engine, params },

#define REGISTER_TEST(test, engine, params) \
	    REGISTER_CPPTESK_TEST(test, engine, params)

typedef enum ScenarioType {CTESK, CPPTESK} ScenarioType;

typedef struct test_registry_item {
    const char *testName;
    ScenarioType testType;
    void *testScenario;
    TestEngine *testEngine;
    const char *testParams;
} test_registry_item;

extern test_registry_item test_registry[];

#ifdef __cplusplus
#include <ts/scenario.hpp>
#endif

#include <agent.h>
#include <generator.h>

#define ACTION_START_OPERATION  1
#define ACTION_FINISH_OPERATION 2

#ifdef __cplusplus
int start_scenario(CppTestScenario *scen, char *params);
int start_net_scenario(CppTestScenario *scen, char *params);
int start_scenario_with_init(CppTestScenario *initscen, cpptesk::ts::CppTestScenario *scen, char *params);
int start_net_scenario_with_init(CppTestScenario *initscen, cpptesk::ts::CppTestScenario *scen, char *params);
int start_scenario_new(CppTestScenario *scen, TestEngine *testEngine, char *params, bool netscen, bool initscen);
#endif
int start_scenario(TestScenario *scen, char *params);
int start_net_scenario(TestScenario *scen, char *params);
int start_scenario_with_init(TestScenario *initscen, TestScenario *scen, char *params);
int start_net_scenario_with_init(TestScenario *initscen, TestScenario *scen, char *params);
int start_scenario_new(TestScenario *scen, TestEngine *testEngine, char *params, bool netscen, bool initscen);

// function points to the procedure with CTESK's start scenario call
int start_scenario_from_function(void(*function)(void));

int end_scenario(void);

int  wait_for_apply(void);
void wait_for_check(void);

void apply_check(void);
void apply_finish(void);
void apply_operation(void);

#endif // _SYNC_H_INCLUDED_
